using namespace std;

class ListenContainer
{
    private:
        Liste kopfelement;
    public:
        ListenContainer()
        {
            //Zunchst leere Liste erzeugen:
            kopfelement.nachfolger = 0;
        }

        //bergebenes String in neues Listen-Element packen und dieses an das Ende der Liste hngen
        void append(string text)
        {
            Liste* element = new Liste(text);
            Liste* zeiger = &kopfelement;

            while(zeiger->nachfolger!=0)
                zeiger = zeiger->nachfolger;

            zeiger->nachfolger = element;
        }  

        //Refrerenz auf das i-te Listenelement suchen und dessen String-Inhalt zurckgeben
        string get(int index)
        {
            Liste* zeiger = kopfelement.nachfolger;

            for(int i=0;i<index;i++)
            {
                if(zeiger == 0)
                    return 0;
                zeiger = zeiger->nachfolger;
            }                    

            return zeiger->daten;      
        }

        //i-tes Listenelement lschen
        void del(int index)
        {
            //Hier muss der Zeiger auf das vorangehende und das nachfolgende Element
            //efunden werden.
            Liste* zeiger     = kopfelement.nachfolger;
            Liste* zeigervor  = &kopfelement;
            Liste* zeigernach = 0;            

            for(int i=0;i<index;i++)
            {
                if(zeiger == 0)
                    return;
                zeigervor = zeiger;
                zeiger = zeiger->nachfolger;
            }                    
            zeigernach = zeiger->nachfolger;
            
            //Vorgnger-Element mit Nachfolger-Element verbinden:
            zeigervor->nachfolger = zeigernach;

            //Speicher fr aktuelles Element freigeben:
            delete zeiger;
        }

        //die ganze Liste lschen.
        void clear()
        {                 
            Liste* zeiger;
            Liste* zeigervor  = &kopfelement;

            //Speicher bereinigen:
            while(kopfelement.nachfolger != 0)
            {
                zeiger    = kopfelement.nachfolger;
                zeigervor = &kopfelement;                
                while(zeiger->nachfolger != 0)
                {
                    zeigervor = zeiger;
                    zeiger = zeiger->nachfolger;
                }
                zeigervor->nachfolger=0;
                delete zeiger;
            }
        }

        //Liefert die Lnge der Liste zurck
        int getSize()
        {
            int laenge = 0;
            Liste* zeiger = &kopfelement;
            
            while(zeiger->nachfolger!=0)
            {
                laenge++;
                zeiger = zeiger->nachfolger;
            }

            return laenge;
        }
 };
