#include <string>
#include <iostream>

#include "Liste.h"
#include "ListenContainer.h"

using namespace std;

bool istTrennzeichen(char zeichen, string trennzeichen)
{
    for(int i=0;i<trennzeichen.size();i++)
    {
        if(zeichen == trennzeichen.at(i))
            return true;
    }
    return false;
}


void zerlegeText(ListenContainer* mLC,string text,string trennzeichen)
{
    int wortbeginn = 0;
    int wortende   = 0;

    for(int i=0;i<text.size();i++)
    {
        if(  !istTrennzeichen(text.at(i),trennzeichen) )
        {
            wortbeginn = i;
            while( i+1<text.size() && !istTrennzeichen(text.at(i+1),trennzeichen) )
                i++;

            wortende = i;
            mLC->append(text.substr(wortbeginn,wortende-wortbeginn+1));            
        }
    }
}


int main(void)
{

    string text = "Das ist ein Text.";        
    string trennzeichen = ".,;: ";
    ListenContainer mLC;

//einige Tests vorab:
    mLC.append("Test0");
    mLC.append("Test1");
    mLC.append("Test2");
    mLC.del(1);
    cout<<"GROESSE der Liste="<<mLC.getSize()<<endl;
    cout<<"Wort Nr."<<1<<":"<<mLC.get(1)<<endl;   
    mLC.clear(); 
//einige Tests vorab: ENDE

    zerlegeText(&mLC,text,trennzeichen);

    cout<<"GROESSE der Liste="<<mLC.getSize()<<endl;

    for(int i=0;i<mLC.getSize();i++)
        cout<<"Wort Nr."<<i<<":"<<mLC.get(i)<<endl;    


}
